1Consider the graph below, where :math:`f(x) = x^2 + 3`.

The slope between (1,4) and (3,12) would be:

.. math::
    slope = \frac{y2-y1}{x2-x1} = \frac{12-4}{3-1} = 4

05/2022 Reviews
    * Finding derivatives: precise Calculus, or rise-over-run method (rise/run)
    * Derivatives chain rule
    * Partial derivative is ... (which is why it's called partial)
    * Gradient is a ...
    * A tangent line is ...
    * A directional derivative gives ...
    * Intergral func: probability, estimate expected val of a random var
    * Gradient explained & visualized by `Khan Academy <https://www.khanacademy.org/math/multivariable-calculus/multivariable-derivatives/gradient-and-directional-derivatives/v/gradient>`_ -> Gradient points to steepest ASCENT

Linear Algebra
    * Vector/matrix (V/M), vectors in geometry/space
    * V/M scalar operations
    * V/M element wise
    * V dot product; M multiplication (a lot in deep learning)
    * V/M hadamard product (hadamard product = broadcasting)
    * Hadamard product of a vector & a matrix (must have same number of rows for corresponding broadcasting)
    * V fields -> represent "mountain/valley" -> Gradient Descent, "directions of steepest descent at any point"
    * Vector fields & contour map `reminder <https://www.khanacademy.org/math/multivariable-calculus/multivariable-derivatives/gradient-and-directional-derivatives/v/gradient-and-contour-maps>`_
    * M transpose: NN often process weights & inputs of different size. Transpose 1 matrix is to match the dimension
requirement for matrix multiplication